#ifndef CORE_INPUT_H_
#define CORE_INPUT_H_

#include "core/pattern/Observer.h"

namespace Core {

class Input
{
  public:
    enum Command
    {
      INVALID = 0,
      UP,
      DOWN,
      LEFT,
      RIGHT,
      STOP,
      ACTION_1,
      ACTION_2,
      NO,
      YES,
      ESCAPE,
      ENTER,
      STATS
    };

  public:
    Input( void );
    ~Input( void );

    static void update( const float _secs );

    static Core::ObserverSubject< const Command >& eventCommand();

    static bool isKeyPressed( int _scanCode );
};

}; //Core

#endif //CORE_INPUT_H_