#ifndef CORE_LOG_H_
#define CORE_LOG_H_

#include <sstream>
#include "core/file/OutputFile.h"

namespace Core
{


class Log
{
public:
  enum LogLevel
  {
    logERROR,
    logWARNING,
    logINFO,
    logDEBUG,
    logDEBUG1,
    logDEBUG2,
    logDEBUG3,
    logDEBUG4
  };

public:
  Log();
  ~Log();
protected:
  static std::ostringstream& string();
  static OutputFile& file();
public:
  static LogLevel& reportingLevel() { static LogLevel s_reportingLevel; return s_reportingLevel; }
  static std::ostringstream& write( const bool doFlush = false );
  static void flush();
};

}; //Core

#define LOG_DEBUG1 \
Core::Log().write() << "debug1  - "

#define LOG_DEBUG2 \
Core::Log().write() << "debug2  - "

#define LOG_DEBUG3 \
Core::Log().write() << "debug3  - "

#define LOG_FLUSH \
LOG_DEBUG1 << "FLUSH\n"; \
Core::Log().flush();

#define LOG_ERROR \
Core::Log().write(true) << "ERROR   - "

#define LOG_WARNING \
Core::Log().write(true) << "WARNING - "

#define LOG_INFO \
Core::Log().write(true) << "info    - "


#endif //CORE_LOG_H_
