#include "Ressources.h"

#include "DarkGDK.h"
#include "Config.h"

using namespace Core;

void loadSprite( const Ressources::Sprite _id, char* _file, const int _prio = 1,  const unsigned _x = 1, const unsigned _y = 1 )
{
	dbSetImageColorKey ( 255, 0, 255 );
	dbCreateAnimatedSprite ( _id, _file, _x, _y, _id );
  dbSprite ( _id, 0, 0, _id );
  dbSetSpritePriority( _id, _prio );
}

Ressources::Ressources(void)
{
	dbLoadImage ( "../data/backdrop.bmp", BACKGROUND );
  dbSprite ( BACKGROUND, 0, 0, BACKGROUND );
  dbSetSpritePriority( BACKGROUND, 0 );

  const int tileSize = Config::get<unsigned>( "sprite.tileSize" );

  loadSprite(FREE, "../data/default/free.png", 1 );
  dbSizeSprite(FREE, tileSize, tileSize);

  loadSprite(ROCK, "../data/default/rock.png", 1 );
  dbSizeSprite(ROCK, tileSize, tileSize);

  loadSprite(SOLID, "../data/default/solid.png", 1 );
  dbSizeSprite(SOLID, tileSize, tileSize);

  loadSprite(PANIC, "../data/default/panic.png", 1 );
  dbSizeSprite(PANIC, tileSize, tileSize);

  loadSprite(BOMBERMAN, "../data/default/bomberman.png", 10, 11, 4 );
  dbSizeSprite(BOMBERMAN, Config::get<unsigned>( "sprite.bombermanX" ), Config::get<unsigned>( "sprite.bombermanX" ));

  dbHideAllSprites();

  dbShowSprite( Ressources::BACKGROUND ); //TODO
}

Ressources::~Ressources(void)
{
  /*
	dbDeleteSprite ( BACKGROUND );
	dbDeleteImage ( BACKGROUND );

  dbDeleteSprite ( FREE );
	dbDeleteImage ( FREE );

  dbDeleteSprite ( ROCK );
	dbDeleteImage ( ROCK );

  dbDeleteSprite ( SOLID );
	dbDeleteImage ( SOLID );

  dbDeleteSprite ( PANIC );
	dbDeleteImage ( PANIC );

  dbDeleteSprite ( BOMBERMAN );
	dbDeleteImage ( BOMBERMAN );
  */
}

const int 
Ressources::getFreeSpriteId()
{
  int i = MAXID;
  while( dbSpriteExist( i ) )
  {
    ++i;
  };
  return i;
}
