#pragma once

#include "Poco/Net/HTTPServer.h"
#include "Poco/Net/HTTPRequestHandler.h"
#include "Poco/Net/HTTPRequestHandlerFactory.h"
#include "Poco/Net/HTTPServerParams.h"
#include "Poco/Net/HTTPServerRequest.h"
#include "Poco/Net/HTTPServerResponse.h"
#include "Poco/Net/HTTPServerParams.h"

using Poco::Net::ServerSocket;
using Poco::Net::HTTPRequestHandler;
using Poco::Net::HTTPRequestHandlerFactory;
using Poco::Net::HTTPServer;
using Poco::Net::HTTPServerRequest;
using Poco::Net::HTTPServerResponse;
using Poco::Net::HTTPServerParams;

namespace Core
{

class RequestHandler: public HTTPRequestHandler
{
public:
	RequestHandler(void)
	{
	}
	
  virtual std::string buildContent( const HTTPServerRequest& request ) { return "content"; };

	void handleRequest(HTTPServerRequest& _request, HTTPServerResponse& refResponse )
	{
//		app.logger().information("Request from " + request.clientAddress().toString());

    std::string content = buildContent( _request );

		refResponse.setChunkedTransferEncoding(true);
		refResponse.setContentType("text/html");

		std::ostream& ostr = refResponse.send();
		ostr << "<html><head><title>HTTPTimeServer powered by POCO C++ Libraries</title>";
		ostr << "<meta http-equiv=\"refresh\" content=\"1\"></head>";
		ostr << "<body>";
		ostr << content;
		ostr << "</body></html>";
	}
};

class RequestHandlerFactory: public HTTPRequestHandlerFactory
{
public:
	RequestHandlerFactory(void){}

	HTTPRequestHandler* createRequestHandler(const HTTPServerRequest& request)
	{
		if (request.getURI() == "/")
    {
			return new RequestHandler;
    }
		else
    {
			return 0;
    }
	}

};

class HttpServer
{
public:
  HttpServer(void);
  ~HttpServer(void);
};

}; //Core