#pragma once

#include "typeid.h"

namespace Data
{

class Type
{
private:
  const TypeId::Type m_id;

public:
  Type();
  ~Type();
  Type( const TypeId::Type _id );

  bool operator< (const Type _in) const { return _in.getId() > m_id; }

protected:
  const TypeId::Type getId() const { return m_id; }

  //////////////////////////
  // CHECKS AND HELPER
public:
  bool isValid() const                { return m_id != TypeId::INVALID; }
  bool isInvalid() const              { return m_id == TypeId::INVALID; }
  static const Type getInvalid()      { return Type( TypeId::INVALID ); }
 
  operator const unsigned () const    { return static_cast<unsigned>( m_id); }
  operator unsigned       ()          { return static_cast<unsigned>( m_id); }
  

  
  //folgende methoden lassen sich auch gut durch templates ersetzen
  bool isCreature() const               { return m_id == TypeId::CREATURE; }
  static const Type getCreature()       { return Type( TypeId::CREATURE ); }
};
}; //Data

