#include "LogicKernel.h"


#include "logic/brain/BombermanBrain.h"
#include "logic/brain/PlayerBrain.h"

#include "data/entity/Creature.h"

#include "network/replica/Replica.h"

#include "core/input/input.h"

using namespace Logic;


LogicKernel::LogicKernel( Data::DataKernel& _dataKernel ) :
  m_dataKernel( _dataKernel )
{
  init();
}

LogicKernel::~LogicKernel(void)
{
  deinit();
}

void
LogicKernel::init()
{
}

void
LogicKernel::deinit()
{
}

void
LogicKernel::reset()
{
  deinit();
  init();
}

void addPlayer()
{
  Data::Creature* creature = new Data::Creature();
  Data::Brain* brain = new PlayerBrain( creature );
  creature->brain( brain );
  Network::Replica::replicaManager().Reference( creature );
}

void addComputer()
{
  Data::Creature* creature = new Data::Creature();
  Data::Brain* brain = new BombermanBrain( creature );
  creature->brain( brain );
  Network::Replica::replicaManager().Reference( creature );
}


void
LogicKernel::update( const float _secs )
{
  m_dataKernel.update( _secs );

  static float delta;
  delta += _secs;

  if( Core::Input::isKeyPressed( 0x2f ) && delta >2.0f )
  {
    delta = 0.0f;
    addPlayer();
  }

  if( Core::Input::isKeyPressed( 0x2e ) && delta >2.0f )
  {
    delta = 0.0f;
    addComputer();
  }
}
