#include "PlayerBrain.h"

#include "data/entity/Creature.h"
#include "data/world/World.h"

using namespace Logic;
using Data::Brain;
using Data::Creature;
using Core::Input;
using Core::Direction;

PlayerBrain::PlayerBrain( Creature* _body ) :
  Brain ( _body )
{
  m_commandObserver.host( this );
}

PlayerBrain::~PlayerBrain(void)
{
}

void
PlayerBrain::update( const float& _secs )
{
 while ( !( m_commands.empty() ) )
  {
    Core::Input::Command command = m_commands.front();
    m_commands.pop();

    switch( command )
    {
      case Input::UP :
      {
        m_body->direction( Direction::UP );
        m_body->setToMaxSpeed();
        break;
      }
      case Input::DOWN :
      {
        m_body->direction( Direction::DOWN );
        m_body->setToMaxSpeed();
        break;
      }
      case Input::LEFT :
      {
        m_body->direction( Direction::LEFT );
        m_body->setToMaxSpeed();
        break;
      }
      case Input::RIGHT :
      {
        m_body->direction( Direction::RIGHT );
        m_body->setToMaxSpeed();
        break;
      }
      case Input::STOP :
      {
        m_body->speed( 0.0f );
        break;
      }
    }
  }
}

