#pragma once

#include "data/brain/Brain.h"

#include "core/input/Input.h"

#include <queue>

namespace Logic {

class PlayerBrain : public Data::Brain
{
public:
  PlayerBrain( Data::Creature* _body );
  virtual ~PlayerBrain( void );

  virtual void update( const float& _secs );

private:
  std::queue< Core::Input::Command > m_commands;

  class CommandObserver : public Core::Observer< const Core::Input::Command >
  {
    public:
      CommandObserver()
      {
        Core::Input::eventCommand().add( this );
      }

      void host( PlayerBrain* _host )
      {
        m_host = _host;
      }

      virtual void notify( const Core::Input::Command _command ) 
      {
        m_host->m_commands.push( _command );
      }
    private:
      PlayerBrain* m_host;
  } m_commandObserver;
};

}; //Logic