#include "ReplicaFactory.h"



namespace Network
{

ReplicaFactory::ReplicaFactory()
{
}

ReplicaFactory::~ReplicaFactory()
{
}

Factories&
ReplicaFactory::factories()
{
  static Factories s_factories;
  return s_factories;
}


void
ReplicaFactory::registerFactory(const Type& _type, FactoryCreateFunction _factory)
{
  factories()[_type] = _factory;
}

Replica*
ReplicaFactory::create( const Type _type )
{
  Factories::const_iterator it = factories().find( _type );
  if( it != factories().end() )
  {
    Replica* replica = (it->second)();

    return replica;
  }
  //PANIC
  return 0;
}


}; //Network