#include "Sprite.h"

#include "DarkGDK.h"

using namespace Render;
using Core::Ressources;

Sprite::Sprite( void ) : m_spriteId( -1 )
{
}

Sprite::Sprite( Ressources::Sprite _sprite )
{
  set( _sprite );
}

Sprite::~Sprite( void )
{
  unset();
}

          
void
Sprite::set( Ressources::Sprite _sprite )
{
  if( isValid() )
  {
    unset();
  }

  m_spriteId = Ressources::getFreeSpriteId();
  dbCloneSprite( _sprite , m_spriteId );
}

void
Sprite::unset()
{
  if( isValid() )
  {
    hide();
    dbDeleteSprite( m_spriteId );
    m_spriteId = -1;
  }
}


void
Sprite::show() const
{
  dbShowSprite( m_spriteId );
}

void
Sprite::hide() const
{
  dbHideSprite( m_spriteId );
}

bool
Sprite::isValid() const
{
  return ( m_spriteId >= 0 );
}

void
Sprite::setPosition( const Int2d& _pos ) const
{
  dbSprite( m_spriteId, _pos.x(),  _pos.y(), dbSpriteImage( m_spriteId ) );
}

