#pragma once

#include "core/ressources/Ressources.h"
#include "core/types/Vector2d.h"

namespace Render {

class Sprite
{
  public:
    Sprite( void );
    Sprite( Core::Ressources::Sprite _sprite );
    virtual ~Sprite(void);

    void show() const;
    void hide() const;

    bool isValid() const;
    void set( Core::Ressources::Sprite _sprite );
    void unset();

    void setPosition( const Int2d& _pos ) const;

  protected:
    int   m_spriteId;
};

}; //Render